gtkmm: Gtk::GestureStylus Class Reference

gtkmm 4.7.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::GestureStylus Class Reference
Event Controllers and Gestures

Gesture for stylus input. More...

`#include <gtkmm/gesturestylus.h>`

Inheritance diagram for Gtk::GestureStylus:
[legend]

## Public Member Functions
| GestureStylus (GestureStylus && src) noexcept
GestureStylus & | operator= (GestureStylus && src) noexcept
| ~GestureStylus () noexcept override
GtkGestureStylus * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGestureStylus * | gobj () const
| Provides access to the underlying C GObject. More...
GtkGestureStylus * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
std::optional< double > | get_axis (Gdk::AxisUse axis) const
| Returns the current value for the requested axis. More...
std::vector< double > | get_axes (const std::vector< Gdk::AxisUse > & axes) const
| Returns the current values for the requested axes. More...
std::vector< Gdk::TimeCoord > | get_backlog () const
| By default, GTK+ will limit rate of input events. More...
Glib::RefPtr< Gdk::DeviceTool > | get_device_tool ()
| Returns the Gdk::DeviceTool currently driving input through this gesture. More...
Glib::RefPtr< const Gdk::DeviceTool > | get_device_tool () const
| Returns the Gdk::DeviceTool currently driving input through this gesture. More...
Glib::SignalProxy< void(double, double)> | signal_proximity ()
Glib::SignalProxy< void(double, double)> | signal_down ()
Glib::SignalProxy< void(double, double)> | signal_motion ()
Glib::SignalProxy< void(double, double)> | signal_up ()
Public Member Functions inherited from Gtk::GestureSingle
| GestureSingle (GestureSingle && src) noexcept
GestureSingle & | operator= (GestureSingle && src) noexcept
| ~GestureSingle () noexcept override
GtkGestureSingle * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGestureSingle * | gobj () const
| Provides access to the underlying C GObject. More...
GtkGestureSingle * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | get_touch_only () const
| Returns `true` if the gesture is only triggered by touch events. More...
void | set_touch_only (bool touch_only=true)
| Sets whether to handle only touch events. More...
bool | get_exclusive () const
| Gets whether a gesture is exclusive. More...
void | set_exclusive (bool exclusive=true) const
| Sets whether gesture is exclusive. More...
unsigned int | get_button () const
| Returns the button number gesture listens for. More...
void | set_button (unsigned int button=0)
| Sets the button number gesture listens to. More...
unsigned int | get_current_button () const
| Returns the button number currently interacting with gesture, or 0 if there is none. More...
Gdk::EventSequence * | get_current_sequence ()
| Returns the event sequence currently interacting with gesture. More...
const Gdk::EventSequence * | get_current_sequence () const
| Returns the event sequence currently interacting with gesture. More...
Glib::PropertyProxy< bool > | property_touch_only ()
| Whether the gesture handles only touch events. More...
Glib::PropertyProxy_ReadOnly< bool > | property_touch_only () const
| Whether the gesture handles only touch events. More...
Glib::PropertyProxy< bool > | property_exclusive ()
| Whether the gesture is exclusive. More...
Glib::PropertyProxy_ReadOnly< bool > | property_exclusive () const
| Whether the gesture is exclusive. More...
Glib::PropertyProxy< unsigned int > | property_button ()
| Mouse button number to listen to, or 0 to listen for any button. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_button () const
| Mouse button number to listen to, or 0 to listen for any button. More...
Public Member Functions inherited from Gtk::Gesture
| Gesture (Gesture && src) noexcept
Gesture & | operator= (Gesture && src) noexcept
| ~Gesture () noexcept override
GtkGesture * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGesture * | gobj () const
| Provides access to the underlying C GObject. More...
GtkGesture * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the logical `Gdk::Device` that is currently operating on gesture. More...
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the logical `Gdk::Device` that is currently operating on gesture. More...
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with. More...
EventSequenceState | get_sequence_state (Gdk::EventSequence * sequence) const
| Returns the sequence state, as seen by gesture. More...
bool | set_sequence_state (Gdk::EventSequence * sequence, EventSequenceState state)
| Sets the state of sequence in gesture. More...
std::vector< const Gdk::EventSequence * > | get_sequences () const
| Returns the list of Gdk::EventSequences currently being interpreted. More...
Gdk::EventSequence * | get_last_updated_sequence ()
| Returns the `Gdk::EventSequence` that was last updated on gesture. More...
const Gdk::EventSequence * | get_last_updated_sequence () const
| Returns the `Gdk::EventSequence` that was last updated on gesture. More...
bool | handles_sequence (Gdk::EventSequence * sequence) const
| Returns `true` if gesture is currently handling events corresponding to sequence. More...
Glib::RefPtr< Gdk::Event > | get_last_event (Gdk::EventSequence * sequence)
| Returns the last event that was processed for sequence. More...
Glib::RefPtr< const Gdk::Event > | get_last_event (Gdk::EventSequence * sequence) const
| Returns the last event that was processed for sequence. More...
bool | get_point (Gdk::EventSequence * sequence, double & x, double & y) const
| If sequence is currently being interpreted by gesture, returns `true` and fills in x and y with the last coordinates stored for that event sequence. More...
bool | get_bounding_box (Gdk::Rectangle & rect) const
| If there are touch sequences being currently handled by gesture, returns `true` and fills in rect with the bounding box containing all active touches. More...
bool | get_bounding_box_center (double & x, double & y) const
| If there are touch sequences being currently handled by gesture, returns `true` and fills in x and y with the center of the bounding box containing all active touches. More...
bool | is_active () const
| Returns `true` if the gesture is currently active. More...
bool | is_recognized () const
| Returns `true` if the gesture is currently recognized. More...
void | group (const Glib::RefPtr< Gesture > & group_gesture)
| Adds gesture to the same group than group_gesture. More...
void | ungroup ()
| Separates gesture into an isolated group. More...
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture. More...
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture. More...
bool | is_grouped_with (const Glib::RefPtr< Gesture > & other) const
| Returns `true` if both gestures pertain to the same group. More...
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_begin ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_end ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_update ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_cancel ()
Glib::SignalProxy< void(Gdk::EventSequence *, EventSequenceState)> | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture. More...
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget * | get_widget ()
| Returns the `Gtk::Widget` this controller relates to. More...
const Widget * | get_widget () const
| Returns the `Gtk::Widget` this controller relates to. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller. More...
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller. More...
Glib::ustring | get_name () const
| Gets the name of controller. More...
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging. More...
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller. More...
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller. More...
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller. More...
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller. More...
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller. More...
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the `Gdk::Events` that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle. More...
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle. More...
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< GestureStylus > | create ()
| Creates a GestureStylus. More...
Static Public Member Functions inherited from Gtk::GestureSingle
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Gesture
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| GestureStylus ()
| Constructs a GestureStylus. More...
Protected Member Functions inherited from Gtk::GestureSingle
| GestureSingle ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Gtk::Gesture
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::GestureStylus > | wrap (GtkGestureStylus * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::GestureSingle
Glib::RefPtr< Gtk::GestureSingle > | wrap (GtkGestureSingle * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Gesture
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Gesture for stylus input.

Gtk::GestureStylus is a Gtk::Gesture implementation specific to stylus input. The provided signals just provide the basic information.

Since gtkmm 3.94:

## Constructor & Destructor Documentation

## ◆ GestureStylus() [1/2]

Gtk::GestureStylus::GestureStylus | ( | GestureStylus && | src | ) |
| noexcept

## ◆ ~GestureStylus()

Gtk::GestureStylus::~GestureStylus | ( |  | ) |
| overridenoexcept

## ◆ GestureStylus() [2/2]

Gtk::GestureStylus::GestureStylus | ( |  | ) |
| protected

Constructs a GestureStylus.

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<GestureStylus> Gtk::GestureStylus::create | ( |  | ) |
| static

Creates a GestureStylus.

Returns
  A RefPtr to a new GestureStylus.

## ◆ get_axes()

std::vector<double> Gtk::GestureStylus::get_axes | ( | const std::vector< Gdk::AxisUse > & | axes | ) | const

Returns the current values for the requested axes.

This function must be called from either the signal_down(), signal_motion(), signal_up() or signal_proximity() signal handlers.

Parameters

  axes | Vector of requested axes. Don't include Gdk::AxisUse::IGNORE in the vector. The underlying GTK+ function would interpret it as an end-of-array mark.

Returns
  The current values for the axes. If there are no values, an empty vector is returned.

## ◆ get_axis()

std::optional<double> Gtk::GestureStylus::get_axis | ( | Gdk::AxisUse | axis | ) | const

Returns the current value for the requested axis.

This function must be called from either the signal_down(), signal_motion(), signal_up() or signal_proximity() signal handlers.

Parameters

  axis | Requested device axis.

Returns
  The current value for the axis, if any.

## ◆ get_backlog()

std::vector<Gdk::TimeCoord> Gtk::GestureStylus::get_backlog | ( |  | ) | const

By default, GTK+ will limit rate of input events.

On stylus input where accuracy of strokes is paramount, this function returns the accumulated coordinate/timing state before the emission of the current signal_motion() signal.

This function may only be called within a signal_motion() signal handler, the state given in this signal and obtainable through get_axis() call expresses the latest (most up-to-date) state in motion history.

Returns
  Coordinates and times for the backlog events in chronological order. If there is no backlog to unfold in the current state, an empty vector is returned.

## ◆ get_device_tool() [1/2]

Glib::RefPtr<Gdk::DeviceTool> Gtk::GestureStylus::get_device_tool | ( |  | ) |

Returns the Gdk::DeviceTool currently driving input through this gesture.

This function must be called from either the signal_down(), signal_motion(), signal_up() or signal_proximity() signal handlers.

Returns
  The current stylus tool.

## ◆ get_device_tool() [2/2]

Glib::RefPtr<const Gdk::DeviceTool> Gtk::GestureStylus::get_device_tool | ( |  | ) | const

Returns the Gdk::DeviceTool currently driving input through this gesture.

This function must be called from either the signal_down(), signal_motion(), signal_up() or signal_proximity() signal handlers.

Returns
  The current stylus tool.

## ◆ get_type()

static GType Gtk::GestureStylus::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkGestureStylus* Gtk::GestureStylus::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkGestureStylus* Gtk::GestureStylus::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkGestureStylus* Gtk::GestureStylus::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

GestureStylus& Gtk::GestureStylus::operator= | ( | GestureStylus && | src | ) |
| noexcept

## ◆ signal_down()

Glib::SignalProxy<void(double, double)> Gtk::GestureStylus::signal_down | ( |  | ) |

Slot Prototype:
  `void on_my_down(double x, double y)`

Flags: Run Last

Emitted when the stylus touches the device.

Parameters

  x | The X coordinate of the stylus event.
  y | The Y coordinate of the stylus event.

## ◆ signal_motion()

Glib::SignalProxy<void(double, double)> Gtk::GestureStylus::signal_motion | ( |  | ) |

Slot Prototype:
  `void on_my_motion(double x, double y)`

Flags: Run Last

Emitted when the stylus moves while touching the device.

Parameters

  x | The X coordinate of the stylus event.
  y | The Y coordinate of the stylus event.

## ◆ signal_proximity()

Glib::SignalProxy<void(double, double)> Gtk::GestureStylus::signal_proximity | ( |  | ) |

Slot Prototype:
  `void on_my_proximity(double x, double y)`

Flags: Run Last

Emitted when the stylus is in proximity of the device.

Parameters

  x | The X coordinate of the stylus event.
  y | The Y coordinate of the stylus event.

## ◆ signal_up()

Glib::SignalProxy<void(double, double)> Gtk::GestureStylus::signal_up | ( |  | ) |

Slot Prototype:
  `void on_my_up(double x, double y)`

Flags: Run Last

Emitted when the stylus no longer touches the device.

Parameters

  x | The X coordinate of the stylus event.
  y | The Y coordinate of the stylus event.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::GestureStylus > wrap | ( | GtkGestureStylus * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.